#include <bits/stdc++.h>

using namespace std;

int niz[200000],a[200000],b[200000];

int main()
{
    long long n,q;
    cin>>n;
    for(int i=0;i<n;i++){
        cin>>niz[i];
    }
    niz[n]=0;
    cin>>q;
    for(int i=0;i<q;i++){
        cin>>a[i]>>b[i];
    }
    for(int i=0;i<q;i++){
        int brojac=0;
        for(int j=a[i]-1;j<b[i]-2;j++){
            if(brojac>1)break;
            if(niz[j]>niz[j+1]){
                if(niz[j+2]==0)brojac++;
                else{
                    if(niz[j]>niz[j+2]&&niz[j+1]<niz[j-1]){
                        brojac=brojac+2;
                    }
                    else brojac++;
                }
            }
        }
        if(brojac<=1)cout<<"DA \n";
        else{
            cout<<"NE \n";
        }
    }
    return 0;
}